'ChirpPix for IQ output

'by Markus Vester, DF6NM

'history:
'bmftwa2d 15.12.1999, 2f 18.06.2000, 2g 20.12.2002, 2h 6.3.2003
'2j 10.3.2003 cos^2-windowed fft
'2n 2.4.2003 reads 8 and 24 bit bmps
'ChirpPix.bas 2. Apr 03
'chirppi2.bas 20.12.2006: /noasm option to choose between assembler and basic FFT code
'chichi1 5.1.2011: IQ sndoutpt, chireix outphasing
'chichi2 15.2.2011: chirpstart, phase multiplication / division, phase offset
'chirpix3 29.3.2011: chireix postprocessing moved to external program, free filename extensions
'3a: 15.4.2011, 22.4.2011

'$DYNAMIC
 DEFINT I-N


 CLEAR
 PRINT "Chirped Fourier Picture Transmission by DF6NM"

 pi! = 4 * ATN(1)

'set defaults and read cmdline parameters
 path$ = ""

 comm$ = COMMAND$
 'comm$ = " /infile test.bmp /tmpfile garx.tmp  xx /outfile bla.dat"
 'comm$ = "/asm"
 comm$ = UCASE$(comm$) + " "

 IF INSTR(comm$, "?") > 0 OR INSTR(comm$, "/help") > 0 THEN
  PRINT "command line parameters and defaults:"
  PRINT "/infile image.bmp /tmpfile iq.tmp /outfile iq.dat /fft 8 /ampl 1 /chirp 1 /chstart 0 [/nowin /asm]"
  GOTO ende
 END IF


 lm = 8
 argp = INSTR(comm$, "/FFT"): IF argp > 0 THEN lm = VAL(MID$(comm$, argp + 4))

 IF lm > 12 THEN lm = 12
 IF lm < 4 THEN lm = 4

 ampl! = 1
 argp = INSTR(comm$, "/AMPL"): IF argp > 0 THEN ampl! = VAL(MID$(comm$, argp + 5))

 chirp! = 1
 argp = INSTR(comm$, "/CHIRP"): IF argp > 0 THEN chirp! = VAL(MID$(comm$, argp + 6))

 chirpstart! = 0
 argp = INSTR(comm$, "/CHSTART"): IF argp > 0 THEN chirpstart! = VAL(MID$(comm$, argp + 8))

 winflag% = 1
 argp = INSTR(comm$, "/NOWIN"): IF argp > 0 THEN winflag% = 0

 file1$ = "image.bmp"
 argp = INSTR(comm$, "/INFILE "): argp2 = INSTR(argp + 8, comm$, " ")
 IF argp > 0 AND argp2 > argp + 8 THEN file1$ = MID$(comm$, argp + 8, argp2 - argp - 8)

 file2$ = "iq.tmp"
 argp = INSTR(comm$, "/TMPFILE "): argp2 = INSTR(argp + 9, comm$, " ")
 IF argp > 0 AND argp2 > argp + 9 THEN file2$ = MID$(comm$, argp + 9, argp2 - argp - 9)

 file3$ = "iq.dat"
 argp = INSTR(comm$, "/OUTFILE "): argp2 = INSTR(argp + 9, comm$, " ")
 IF argp > 0 AND argp2 > argp + 8 THEN file3$ = MID$(comm$, argp + 9, argp2 - argp - 9)

 'PRINT "*"; file1$; "*"; file2$; "*"; file3$; "*"

 file1$ = path$ + file1$
 file2$ = path$ + file2$
 file3$ = path$ + file3$

 fftmcflag% = 0 'use assembler (1) or basic (0) fft
 IF INSTR(comm$, "/ASM") THEN fftmcflag% = 1

 
'prepare FFT
 nm = 2 ^ lm: nm1 = nm - 1
 DIM a!(2 * nm - 1), w!(nm1), nbr%(nm1)
 DIM mc%(155) 'for 312 bytes
 DIM col!(255)
  out$ = STRING$(nm * 4, 0) 'IQ mono

 IF fftmcflag% THEN GOSUB getmc
 GOSUB calcw
 GOSUB calcbitrev

 IF winflag% THEN
  DIM win!(nm1), arold!(nm1), aiold!(nm1)
  GOSUB calcwin
 END IF

 OPEN file1$ FOR INPUT AS 1: CLOSE 1 'check if bmp file exists
 OPEN file1$ FOR BINARY AS 1
 OPEN file2$ FOR OUTPUT AS 2

'read 54 byte bmp-header
 i$ = INPUT$(2, 1)
 IF i$ <> "BM" THEN PRINT "input file not in bmp format": GOTO closefiles
 i$ = INPUT$(8, 1)
 hdrlen = CVL(INPUT$(4, 1))
 i$ = INPUT$(4, 1)
 xm = CVL(INPUT$(4, 1))
 ym = CVL(INPUT$(4, 1))
 i$ = INPUT$(2, 1)
 depth% = CVI(INPUT$(2, 1))
 i$ = INPUT$(24, 1)

 IF depth% <> 8 AND depth% <> 24 THEN PRINT "256 or 16M colours required": GOTO closefiles
 bw! = .11: gw! = .59: rw! = .3 'greyscale colour weights

'read colourmap
 IF depth% <= 8 THEN
  numcols = 2 ^ depth%
  FOR n = 0 TO numcols - 1
   i$ = INPUT$(4, 1)
   col!(n) = bw! * ASC(MID$(i$, 1, 1)) + gw! * ASC(MID$(i$, 2, 1)) + rw! * ASC(MID$(i$, 3, 1))
  NEXT n
 END IF
'bytes per line in bmp
 IF depth% = 8 THEN xm4 = 4 * ((xm + 3) \ 4)
 IF depth% = 24 THEN xm4 = 4 * ((xm * 3 + 3) \ 4)
 ymm = ym + winflag%

 nf1 = -xm \ 2

 ai1old! = 1: ai2old! = -1

'calculate quadratic phasefactors:
 DIM phr!(xm - 1), phi!(xm - 1)
 a0! = .8 * ampl! / 2 / SQR(xm * 2)

 FOR n = 0 TO xm - 1
  ph! = chirp! * (-pi! / xm) * n * (n + chirpstart! * xm)
  phr!(n) = a0! * COS(ph!): phi!(n) = a0! * SIN(ph!)
 NEXT n
  

'Fourier transform lines and write audio data
 FOR y = 0 TO ymm - 1
  FOR n = 0 TO 2 * nm - 1
   a!(n) = 0
  NEXT n
  
  IF y < ym THEN
   LOCATE CSRLIN, 1: PRINT y + 1;
   i$ = INPUT$(xm4, 1)
   FOR n = 0 TO xm - 1
    nn2 = ((n + nf1) AND nm1) * 2
    IF depth% = 24 THEN
     n1 = (xm - 1 - n) * 3 + 1
     ap! = bw! * ASC(MID$(i$, n1, 1)) + gw! * ASC(MID$(i$, n1 + 1, 1)) + rw! * ASC(MID$(i$, n1 + 2, 1))
    ELSE
     ap! = col!(ASC(MID$(i$, xm - n, 1)))
    END IF
    a!(nn2) = ap! * phr!(n): a!(nn2 + 1) = ap! * phi!(n)
   NEXT n

   IF fftmcflag% THEN GOSUB fftmc ELSE GOSUB fftbas

  END IF
 
  nm21 = 2 * nm - 1
  FOR n = 0 TO nm - 1
   IF winflag% THEN
    n2 = (2 * n + nm) AND nm21
    outr! = (a!(n2) * win!(n) + arold!(n) * win!(nm - 1 - n)) * 256
    outi! = -(a!(n2 + 1) * win!(n) + aiold!(n) * win!(nm - 1 - n)) * 256
    arold!(n) = a!(n2)
    aiold!(n) = a!(n2 + 1)
   ELSE
    outr! = a!(n * 2) * 256
    outi! = -a!(n * 2 + 1) * 256
   END IF
  
   omag2! = (outr! * outr! + outi! * outi!)
   IF omag2! > 32767! * 32767 THEN
    omag! = SQR(omag2!)
    outr! = outr! * 32767 / omag!
    outi! = outi! * 32767 / omag!
   END IF
   MID$(out$, 4 * n + 1, 4) = MKI$(outr!) + MKI$(outi!)
  NEXT n
  PRINT #2, out$;

  IF INKEY$ = CHR$(27) THEN GOTO closefiles
  
 NEXT y

 LOCATE CSRLIN, 1: PRINT file2$ + " ready"
 SHELL "ren " + file2$ + " " + file3$

closefiles:
 CLOSE 2
 CLOSE 1
ende:
END

'****************
'FFT stuff

fftmc:
 DEF SEG = VARSEG(mc%(0))
 CALL ABSOLUTE(0)
RETURN

calcw:
'nm/2 warp factors
  sc! = 1
  pi! = 4 * ATN(1)
  FOR n = 0 TO nm \ 2 - 1
   w!(2 * n) = sc! * COS(2 * pi! * n / nm)
   w!(2 * n + 1) = sc! * SIN(2 * pi! * n / nm)
  NEXT n
 RETURN

calcbitrev:
'bit reversal table
  FOR n = 0 TO nm - 1
   n2 = 0: n1 = n
   FOR l = 0 TO lm - 1
    n2 = 2 * n2 + (n1 AND 1)
    n1 = n1 \ 2
   NEXT l
   nbr%(n) = n2
  NEXT n
 RETURN

calcwin:
'cos^2 window
 FOR n = 0 TO nm - 1
  win!(n) = (1! - COS(pi! * n / nm)) / 2!
 NEXT n
RETURN

getmc:
'get FFT code
  RESTORE float4a
  DEF SEG = VARSEG(mc%(0))
  n0 = 0
  READ i$
  WHILE i$ <> "end"
   FOR n = 0 TO LEN(i$) \ 2 - 1
    POKE n0 + n, VAL("&h" + MID$(i$, 2 * n + 1, 2))
   NEXT n
   n0 = n0 + LEN(i$) \ 2
   READ i$
  WEND
  DEF SEG
  mc%(2) = VARSEG(a!(0))
  mc%(3) = VARSEG(w!(0))
  mc%(4) = VARSEG(nbr%(0))
  mc%(5) = lm
  mc%(6) = nm
 RETURN

float4a:
'assembler FFT by Markus Vester, 1999
DATA E9150090000000000000030008000800
DATA 0100000000000000061E2E8E1E04002E
DATA 8E0608002E8B0E0C00BF0000D1E7268B
DATA 35D1EF3BFE7E35C1E603C1E703FF34FF
DATA 358F048F05FF7402FF75028F44028F45
DATA 02FF7404FF75048F44048F4504FF7406
DATA FF75068F44068F4506C1EF0347E2BD2E
DATA 8E0606009BDBE32EC706100001002EA1
DATA 0C00D1E8C1E0032EA30E002EA10A002E
DATA A316002EC706120000002E8B0E10002E
DATA 8B3E12002E8B36120001CEC1E703C1E6
DATA 03BB000026D90726D94704D904D94404
DATA D9C1D8CCD9C1D8CCDEE9D9CAD8CBD9C9
DATA D8CCDEC1D905D94504D9C0D8E3D95C04
DATA D9C1D8E4D91CD8C2D95D04D8C2D91DDD
DATA C3DDC2DDC1DDC083C60883C7082E031E
DATA 0E00E2B02EA112002E030610002E0306
DATA 10002EA312002E3B060C007403E97AFF
DATA 2ED12610002ED12E0E002EFF0E160074
DATA 03E95FFF1F07CB90
DATA end
'==========================================
'original basic fft

fftbas:
 FOR n = 0 TO nm - 1
  n2 = nbr%(n)
  IF n2 < n THEN SWAP a!(2 * n), a!(2 * n2): SWAP a!(2 * n + 1), a!(2 * n2 + 1)
 NEXT n

 nd = 1: nwd = nm \ 2
 FOR l = 0 TO lm - 1
  FOR n0 = 0 TO nm - 1 STEP 2 * nd
   nw = 0
   FOR n1 = n0 TO n0 + nd - 1
    n2 = n1 + nd
   
    n1r = 2 * n1: n1i = n1r + 1
    n2r = 2 * n2: n2i = n2r + 1
    nwr = 2 * nw: nwi = nwr + 1

    vr! = (a!(n2r) * w!(nwr) - a!(n2i) * w!(nwi))
    vi! = (a!(n2i) * w!(nwr) + a!(n2r) * w!(nwi))
    a!(n2r) = a!(n1r) - vr!: a!(n2i) = a!(n1i) - vi!
    a!(n1r) = a!(n1r) + vr!: a!(n1i) = a!(n1i) + vi!
    nw = nw + nwd
   NEXT n1
  NEXT n0
  nd = 2 * nd
  nwd = nwd \ 2
 NEXT l
RETURN

