DECLARE FUNCTION arg! (re!, im!)
'Chireix.bas
'by Markus Vester, DF6NM

'history:
'chichi1 5.1.2011: IQ sndoutpt, chireix outphasing
'chichi2 15.2.2011: chirpstart, phase multiplication / division, phase offset
'chireix1 110329: separated outphasing from chirppix
'chirei1a 110419: 1/pmul filenames

'$DYNAMIC
 DEFINT I-N

 pi! = 4 * ATN(1)

 DEF FNarg (re!, im!)
  IF ABS(im!) < ABS(re!) THEN
    arg1! = ATN(im! / re!)
   IF re! < 0 THEN arg1! = arg1! + pi!
  ELSE
   IF im! = 0 THEN arg1! = 0 ELSE arg1! = pi! / 2 - ATN(re! / im!)
   IF im! < 0 THEN arg1! = arg1! + pi!
  END IF
  FNarg! = arg1!
 END DEF

 PRINT "IQ Outphasing by DF6NM"

'set defaults and read cmdline parameters

 comm$ = COMMAND$
 IF INSTR(comm$, "?") > 0 OR INSTR(comm$, "/help") > 0 THEN
  PRINT "command line parameters and defaults:"
  PRINT "/infile iq.dat /tmpfile iq2.tmp /outfile iq2.dat /am0 1 /am1 .7 /am2 .7 /ph 0 /pmul 1"
  GOTO ende
 END IF
 

 file1$ = "iq.dat"
 argp = INSTR(comm$, "/INFILE "): argp2 = INSTR(argp + 8, comm$, " ")
 IF argp > 0 AND argp2 > argp + 8 THEN file1$ = MID$(comm$, argp + 8, argp2 - argp - 8)
 file2$ = "iq2.tmp"
 argp = INSTR(comm$, "/TMPFILE "): argp2 = INSTR(argp + 9, comm$, " ")
 IF argp > 0 AND argp2 > argp + 9 THEN file2$ = MID$(comm$, argp + 9, argp2 - argp - 9)
 file3$ = "iq2.dat"
 argp = INSTR(comm$, "/OUTFILE "): argp2 = INSTR(argp + 9, comm$, " ")
 IF argp > 0 AND argp2 > argp + 8 THEN file3$ = MID$(comm$, argp + 9, argp2 - argp - 9)
 'PRINT "*"; file1$; "*"; file2$; "*"; file3$; "*"
 path$ = ""
 file1$ = path$ + file1$
 file2$ = path$ + file2$
 file3$ = path$ + file3$

 am0! = 1: argp = INSTR(comm$, "/AM0"): IF argp > 0 THEN am0! = VAL(MID$(comm$, argp + 4))
 am1! = .7: argp = INSTR(comm$, "/AM1"): IF argp > 0 THEN am1! = VAL(MID$(comm$, argp + 4))
 am2! = .7: argp = INSTR(comm$, "/AM2"): IF argp > 0 THEN am2! = VAL(MID$(comm$, argp + 4))
 phoffs! = 0: argp = INSTR(comm$, "/PH"): IF argp > 0 THEN phoffs! = VAL(MID$(comm$, argp + 3))

 'am1! = .65

 am0r! = am0! / 32767
 am1r! = am1! * 32767
 phoffs! = phoffs! * pi! / 180!
 am2r! = am2! * 32767 * COS(phoffs!): am2i! = am2! * 32767 * SIN(phoffs!)
 
 pmul! = 1: argp = INSTR(comm$, "/PMUL"): IF argp > 0 THEN pmul! = VAL(MID$(comm$, argp + 5))
 IF pmul! = 0 THEN pmuldiv! = 1 ELSE pmuldiv! = 1 / pmul!

 OPEN file1$ FOR INPUT AS 1: CLOSE 1 'check if input file exists
 OPEN file1$ FOR BINARY AS 1
 OPEN file2$ FOR OUTPUT AS 2

 bytesleft& = LOF(1)
 blocklen& = 1024
 ai1old! = 1: ai2old! = -1
 ph1! = pi! / 2: ph2! = -pi! / 2
  
   WHILE bytesleft& > 0

    LOCATE CSRLIN, 1: PRINT bytesleft&; "bytes left         ";
    IF bytesleft& < blocklen& THEN blocklen& = bytesleft&
    in$ = INPUT$(blocklen&, #1)
    out$ = STRING$(2 * blocklen&, 0)
   
    bytesleft& = bytesleft& - blocklen&

    FOR n = 0 TO blocklen& \ 4 - 1
     ar! = am0r! * CVI(MID$(in$, 4 * n + 1, 2))
     ai! = am0r! * CVI(MID$(in$, 4 * n + 3, 2))
     'ar! = 1 * SIN(k!): k! = k! + .125: ai! = 0  'two tone test
    
     amag2! = ar! * ar! + ai! * ai!
     IF amag2! > 1! THEN amag! = SQR(amag2!): ar! = ar! / amag!: ai! = ai! / amag!: amag2! = 1
     limit2! = .000001
     IF amag2! < limit2! THEN
      olddiffmag! = SQR((ar1old! - ar2old!) * (ar1old! - ar2old!) + (ai1old! - ai2old!) * (ai1old! - ai2old!))
      oldsummag! = SQR((ar1old! + ar2old!) * (ar1old! + ar2old!) + (ai1old! + ai2old!) * (ai1old! + ai2old!))
      IF olddiffmag! > oldsummag! THEN
       ar1! = (ar1old! - ar2old!) / olddiffmag!
       ai1! = (ai1old! - ai2old!) / olddiffmag!
      ELSE
       ar1! = -(ai1old! + ai2old!) / oldsummag!
       ai1! = (ar1old! + ar2old!) / oldsummag!
      END IF
      ar2! = -ar1!
      ai2! = -ai1!
     ELSE
      IF amag2! < .9999999 THEN qfac! = SQR(1! / amag2! - 1!) ELSE qfac! = 0
      ar1! = ar! - ai! * qfac!: ai1! = ai! + ar! * qfac!
      ar2! = ar! + ai! * qfac!: ai2! = ai! - ar! * qfac!
     END IF
     d1122! = (ar1! - ar1old!) * (ar1! - ar1old!) + (ai1! - ai1old!) * (ai1! - ai1old!) + (ar2! - ar2old!) * (ar2! - ar2old!) + (ai2! - ai2old!) * (ai2! - ai2old!)
     d1212! = (ar1! - ar2old!) * (ar1! - ar2old!) + (ai1! - ai2old!) * (ai1! - ai2old!) + (ar2! - ar1old!) * (ar2! - ar1old!) + (ai2! - ai1old!) * (ai2! - ai1old!)
     IF d1122! > d1212! THEN
      SWAP ar1!, ar2!
      SWAP ai1!, ai2!
     END IF
     'PRINT ar1!; ai1!, ar2!; ai2!, d1122!; d1212!
       
     IF pmuldiv! <> 1! THEN
      'dp=arg(a/aold)
      'px=(px+dp*pmuldiv) mod 2pi
      'ax=exp(j px)  
     
      ph1! = ph1! + pmuldiv! * FNarg(ar1! * ar1old! + ai1! * ai1old!, ai1! * ar1old! - ar1! * ai1old!)
      ph1! = ph1! - 2! * pi! * INT(ph1! / (2! * pi!))
      ar1! = COS(ph1!): ai1! = SIN(ph1!)
      
      ph2! = ph2! + pmuldiv! * FNarg(ar2! * ar2old! + ai2! * ai2old!, ai2! * ar2old! - ar2! * ai2old!)
      ph2! = ph2! - 2 * pi! * INT(ph2! / (2 * pi!))
      ar2! = COS(ph2!): ai2! = SIN(ph2!)
     END IF
      
     ar1old! = ar1!: ai1old! = ai1!
     ar2old! = ar2!: ai2old! = ai2!

     ar1o = (ar1! * am1r!): ai1o = (ai1! * am1r!)
     ar2o = (ar2! * am2r! - ai2! * am2i!): ai2o = (ai2! * am2r! + ar2! * am2i!)
     MID$(out$, 8 * n + 1, 8) = MKI$(ar1o) + MKI$(ai1o) + MKI$(ar2o) + MKI$(ai2o)
      
    NEXT n
    PRINT #2, out$;
    IF INKEY$ = CHR$(27) THEN GOTO closefiles
   WEND

 LOCATE CSRLIN, 1: PRINT file2$ + " ready          "
 SHELL "ren " + file2$ + " " + file3$

closefiles:
 CLOSE 2
 CLOSE 1
ende:
END

